"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../core");
var departments_1 = require("./departments");
var tags_1 = require("./tags");
var users_1 = require("./users");
var ContactsCommander = /** @class */ (function () {
    function ContactsCommander(accessToken) {
        this.accessToken = accessToken;
    }
    Object.defineProperty(ContactsCommander.prototype, "departments", {
        get: function () {
            if (!this._departments) {
                this._departments = new departments_1.DepartmentsCommander(this.accessToken);
            }
            return this._departments;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ContactsCommander.prototype, "users", {
        get: function () {
            if (!this._users) {
                this._users = new users_1.UsersCommander(this.accessToken);
            }
            return this._users;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ContactsCommander.prototype, "tags", {
        get: function () {
            if (!this._tags) {
                this._tags = new tags_1.TagsCommander(this.accessToken);
            }
            return this._tags;
        },
        enumerable: true,
        configurable: true
    });
    ContactsCommander.prototype.invite = function (memberIds, departmentIds, tagIds) {
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if ((!memberIds || memberIds.length === 0) &&
                            (!departmentIds || departmentIds.length === 0) &&
                            (!tagIds || tagIds.length === 0)) {
                            throw Error(core_1.EnumErrors.INVITE_PARAMETERS_ALL_UNDEFINED);
                        }
                        return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/batch/invite?access_token=" + this.accessToken.accessToken;
                        return [4 /*yield*/, core_1.doPost(url, {
                                party: departmentIds,
                                tag: tagIds,
                                user: memberIds
                            })];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, {
                                invalidDepartmentIds: resData.invalidparty,
                                invalidMemberIds: resData.invaliduser,
                                invalidTagIds: resData.invalidtag
                            }];
                }
            });
        });
    };
    ContactsCommander.prototype.batchAddMembers = function (mediaId, toInvite, callback) {
        if (toInvite === void 0) { toInvite = true; }
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/batch/syncuser?access_token=" + this.accessToken.accessToken;
                        return [4 /*yield*/, core_1.doPost(url, {
                                media_id: mediaId,
                                to_invite: toInvite,
                                callback: callback
                            })];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, resData.jobid];
                }
            });
        });
    };
    ContactsCommander.prototype.batchReplaceMembers = function (mediaId, toInvite, callback) {
        if (toInvite === void 0) { toInvite = true; }
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/batch/replaceuser?access_token=" + this.accessToken.accessToken;
                        return [4 /*yield*/, core_1.doPost(url, {
                                media_id: mediaId,
                                to_invite: toInvite,
                                callback: callback
                            })];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, resData.jobid];
                }
            });
        });
    };
    ContactsCommander.prototype.batchReplaceDepartments = function (mediaId, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/batch/replaceparty?access_token=" + this.accessToken.accessToken;
                        return [4 /*yield*/, core_1.doPost(url, {
                                media_id: mediaId,
                                callback: callback
                            })];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, resData.jobid];
                }
            });
        });
    };
    ContactsCommander.prototype.getBatchResult = function (jobId) {
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/batch/getresult?access_token=" + this.accessToken.accessToken + "&jobid=" + jobId;
                        return [4 /*yield*/, core_1.doGet(url)];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, resData];
                }
            });
        });
    };
    return ContactsCommander;
}());
exports.ContactsCommander = ContactsCommander;
//# sourceMappingURL=commander.class.js.map