import { AccessToken, CommanderParent } from "../../core";
import { SimpleUser } from "../users";
import { IInvalid } from "./invalid.interface";
import { Tag } from "./tag.class";
export declare class TagsCommander extends CommanderParent {
    constructor(accessToken: AccessToken);
    find(): Promise<Tag[]>;
    create(tag: Tag): Promise<Tag>;
    update(tag: Tag): Promise<void>;
    delete(id: number): Promise<void>;
    findBindings(tagId: number): Promise<{
        departmentIdList: number[];
        memberList: SimpleUser[];
        tag: Tag;
    }>;
    addBindings(tagId: number, memberIds: string[], departmentIds: number[]): Promise<IInvalid>;
    removeBindings(tagId: number, memberIds: string[], departmentIds: number[]): Promise<IInvalid>;
}
