"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../../core");
var user_class_1 = require("./user.class");
var debug_1 = __importDefault(require("debug"));
var debugThis = debug_1.default("wechat-work:users-commander");
var UsersCommander = /** @class */ (function (_super) {
    __extends(UsersCommander, _super);
    function UsersCommander(accessToken) {
        return _super.call(this, accessToken) || this;
    }
    UsersCommander.prototype.create = function (member) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/user/create?access_token=" + this.accessToken.accessToken;
                        return [4 /*yield*/, core_1.doPost(url, member)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    UsersCommander.prototype.findById = function (userId) {
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/user/get?access_token=" + this.accessToken.accessToken + "&userid=" + userId;
                        return [4 /*yield*/, core_1.doGet(url)];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, new user_class_1.User(resData)];
                }
            });
        });
    };
    UsersCommander.prototype.update = function (user) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/user/update?access_token=" + this.accessToken.accessToken;
                        return [4 /*yield*/, core_1.doPost(url, user)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    UsersCommander.prototype.deleteById = function (userId) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/user/delete?access_token=" + this.accessToken.accessToken + "&userid=" + userId;
                        return [4 /*yield*/, core_1.doGet(url)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    UsersCommander.prototype.delete = function (userIds) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/user/batchdelete?access_token=" + this.accessToken.accessToken;
                        return [4 /*yield*/, core_1.doPost(url, { useridlist: userIds })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    UsersCommander.prototype.findByDepartmentSimple = function (departmentId, fetchChild) {
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/user/simplelist?access_token=" + this.accessToken.accessToken + "&department_id=" + departmentId + "&fetch_child=" + fetchChild;
                        return [4 /*yield*/, core_1.doGet(url)];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, resData.userlist];
                }
            });
        });
    };
    UsersCommander.prototype.findByDepartment = function (departmentId, fetchChild) {
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/user/list?access_token=" + this.accessToken.accessToken + "&department_id=" + departmentId + "&fetch_child=" + fetchChild;
                        return [4 /*yield*/, core_1.doGet(url)];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, resData.userlist.map(function (user) {
                                return new user_class_1.User(user);
                            })];
                }
            });
        });
    };
    UsersCommander.prototype.convertToOpenId = function (userId) {
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/user/convert_to_openid?access_token=" + this.accessToken.accessToken;
                        return [4 /*yield*/, core_1.doPost(url, { userid: userId })];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, resData.openid];
                }
            });
        });
    };
    UsersCommander.prototype.convertToUserId = function (openId) {
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/user/convert_to_userid?access_token=" + this.accessToken.accessToken;
                        return [4 /*yield*/, core_1.doPost(url, { openid: openId })];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, resData.openid];
                }
            });
        });
    };
    UsersCommander.prototype.internalAuthResult = function (userId) {
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/user/authsucc?access_token=" + this.accessToken.accessToken + "&userid=" + userId;
                        return [4 /*yield*/, core_1.doGet(url, false)];
                    case 2:
                        resData = _a.sent();
                        return [2 /*return*/, resData.errmsg];
                }
            });
        });
    };
    return UsersCommander;
}(core_1.CommanderParent));
exports.UsersCommander = UsersCommander;
//# sourceMappingURL=commander.class.js.map