import { AccessToken, EnumSecretType, IConfig } from ".";
import { AppMessagesCommander } from "../app-messages";
import { ContactsCommander } from "../contacts";
import { CustomizedAppsCommander } from "../customized-apps";
import { ExternalContactCommander } from "../external-contacts";
import { JsSdkCommander } from "../jssdk";
import { MiniProgramCommander } from "../mini-programs/mini-programs.commander.class";
import { MediaCommander } from "./../media/media-commander";
export declare class Commander {
    private config;
    constructor(config: IConfig);
    getContactsCommander(secretType?: EnumSecretType, agentId?: string): Promise<ContactsCommander>;
    getExternalContactsCommander(): Promise<ExternalContactCommander>;
    getAccessToken(secretType: EnumSecretType, agentId?: string): Promise<AccessToken>;
    getCustomizedAppCommander(agentId: string): Promise<CustomizedAppsCommander>;
    getMiniProgramCommander(agentId: string): Promise<MiniProgramCommander>;
    getJsSdkCommander(agentId: string): Promise<JsSdkCommander>;
    getAppMessagesCommander(agentId: string): Promise<AppMessagesCommander>;
    getMediaCommander(agentId: string): Promise<MediaCommander>;
}
