import { AuthScope, CustomizedApp, CustomizedAppSimple, ICustomizedAppConfig } from ".";
import { AccessToken, CommanderParent } from "../core";
export declare class CustomizedAppsCommander extends CommanderParent {
    private agentId;
    constructor(accessToken: AccessToken, agentId: string);
    findById(agentId: string): Promise<CustomizedApp>;
    config(config: ICustomizedAppConfig): Promise<void>;
    find(): Promise<CustomizedAppSimple[]>;
    getUserInfoByCode(authScope: AuthScope, code: string): Promise<{
        deviceId: any;
        openId: any;
        userId: any;
    }>;
    getUserDetailByTicket(userTicket: string): Promise<{
        avatar: string;
        email?: string | undefined;
        gender: string;
        mobile?: string | undefined;
        name: string;
        qrCode: string;
        userId: string;
    }>;
}
