"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../core");
var common_helpers_1 = require("../core/common-helpers");
var constants_1 = require("../core/constants");
var fetching = {}; // TODO: multi server
var JsApiTicket = /** @class */ (function () {
    function JsApiTicket(corpId, ticket, expiresIn, agentId, accessToken, config) {
        this.ticket = ticket;
        this.expiresIn = expiresIn;
        this.createdAt = Date.now();
        this.expiresAt = this.createdAt + this.expiresIn * 1000;
        this.corpId = corpId;
        this.agentId = agentId;
        this.config = config;
        this.accessToken = accessToken;
    }
    JsApiTicket.get = function (config, agentId, accessToken) {
        return __awaiter(this, void 0, void 0, function () {
            var key, cachedJsApiTicket, deSerialized, deSerialized, fetched;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        key = JsApiTicket.key(config.corpId, agentId);
                        return [4 /*yield*/, config.getFromCacheMethod(key)];
                    case 1:
                        cachedJsApiTicket = _a.sent();
                        if (cachedJsApiTicket && cachedJsApiTicket.content) {
                            if (cachedJsApiTicket.ttlSeconds) {
                                if (cachedJsApiTicket.ttlSeconds > constants_1.ACCESS_TOKEN_EXPIRE_CUTOFF) {
                                    deSerialized = JsApiTicket.deSerialize(cachedJsApiTicket.content, accessToken, cachedJsApiTicket.ttlSeconds);
                                    deSerialized.config = config;
                                    return [2 /*return*/, deSerialized];
                                }
                            }
                            else {
                                deSerialized = JsApiTicket.deSerialize(cachedJsApiTicket.content, accessToken);
                                if (deSerialized.expiresIn > 600) {
                                    deSerialized.config = config;
                                    // internally maintained ttl is valid
                                    return [2 /*return*/, deSerialized];
                                }
                            }
                        }
                        if (!(fetching[key] === true)) return [3 /*break*/, 4];
                        return [4 /*yield*/, common_helpers_1.timer(100)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, JsApiTicket.get(config, agentId, accessToken)];
                    case 3: return [2 /*return*/, _a.sent()];
                    case 4:
                        fetching[key] = true;
                        return [4 /*yield*/, JsApiTicket.fetch(config, agentId, accessToken)];
                    case 5:
                        fetched = _a.sent();
                        fetched.config = config;
                        return [4 /*yield*/, config.saveToCacheMethod(fetched.key, fetched.serialized, fetched.expiresIn)];
                    case 6:
                        _a.sent();
                        fetching[key] = false;
                        return [2 /*return*/, fetched];
                }
            });
        });
    };
    JsApiTicket.deSerialize = function (serialized, accessToken, ttlSeconds) {
        if (!serialized) {
            throw Error("serialized access token can not be an empty string.");
        }
        var splited = serialized.split("|");
        if (splited.length !== 4) {
            throw Error("invalid serialized access token.");
        }
        var expiresIn = ttlSeconds
            ? ttlSeconds
            : (parseInt(splited[1], 10) - Date.now()) / 1000;
        return new JsApiTicket(splited[2].trim(), splited[0].trim(), expiresIn, splited[4], accessToken);
    };
    JsApiTicket.fetch = function (config, agentId, accessToken) {
        return __awaiter(this, void 0, void 0, function () {
            var url, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, accessToken.ensureNotExpired()];
                    case 1:
                        _a.sent();
                        url = "https://qyapi.weixin.qq.com/cgi-bin/get_jsapi_ticket?access_token=" + accessToken.accessToken;
                        return [4 /*yield*/, core_1.doGet(url)];
                    case 2:
                        resData = (_a.sent());
                        return [2 /*return*/, new JsApiTicket(config.corpId, resData.ticket, resData.expires_in, agentId, accessToken)];
                }
            });
        });
    };
    JsApiTicket.key = function (corpId, agentId) {
        return "WECHAT_WORK_JSAPI_TICKET_CORP_" + corpId + "_AGENT_" + agentId;
    };
    JsApiTicket.prototype.isExpired = function () {
        return this.expiresAt <= Date.now();
    };
    Object.defineProperty(JsApiTicket.prototype, "key", {
        get: function () {
            return JsApiTicket.key(this.corpId, this.agentId);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JsApiTicket.prototype, "serialized", {
        get: function () {
            return this.ticket + "|" + this.expiresAt + "|" + this.corpId + "|" + this.agentId;
        },
        enumerable: true,
        configurable: true
    });
    JsApiTicket.prototype.ensureNotExpired = function () {
        return __awaiter(this, void 0, void 0, function () {
            var token;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.isExpired()) return [3 /*break*/, 2];
                        if (!this.config) {
                            throw Error(core_1.EnumErrors.CONFIG_SHOULD_PROVIDED);
                        }
                        return [4 /*yield*/, JsApiTicket.get(this.config, this.agentId, this.accessToken)];
                    case 1:
                        token = _a.sent();
                        this.ticket = token.ticket;
                        this.createdAt = token.createdAt;
                        this.expiresAt = token.expiresAt;
                        this.expiresIn = token.expiresIn;
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    return JsApiTicket;
}());
exports.JsApiTicket = JsApiTicket;
//# sourceMappingURL=jsapi-ticket.class.js.map