/// <reference types="node" />
import { AccessToken, CommanderParent } from "../core";
import { ReadStream } from 'fs';
export declare type MediaType = "image" | "voice" | "video" | "file";
export declare class MediaCommander extends CommanderParent {
    constructor(accessToken: AccessToken);
    download(mediaId: string, destPath: string): Promise<unknown>;
    uploadTemp(stream: ReadStream, fileType: MediaType, filename: string): Promise<{
        createdAt: Date;
        mediaId: string;
        type: MediaType;
    }>;
    uploadImage(stream: ReadStream, filename: string): Promise<{
        url: string;
    }>;
}
